/************************************************************************\
 *
 * CES Vault Wiki
 * Version 3.0.17
 *
 * Copyright 2008-2012 Cracked Egg Studios. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 * 
 * VAULTWIKI IS NOT FREE SOFTWARE
 * http://www.vaultwiki.org/
 * http://www.vaultwiki.org/pages/License-Agreement
 *
\************************************************************************/

// #############################################################################
// vB_ResetHandler
// #############################################################################
function vB_ResetHandler()
{
	// handles adding of JS and CSS
};

/**
* Process HTML after a redirect
*
* @param	ajax	response
* @param	string	article URL
*
* @return	boolean	false
*/
vB_ResetHandler.prototype.parseRedirect = function(ajax_response, thread_url)
{
	var splitter = thread_url.indexOf('?') != -1 ? '?' : '&';
	var tabResponse = fetch_tags(ajax_response, "tabs")[0];

	if (!tabResponse || !tabResponse.firstChild)
	{
		return false;
	}

	this.insertPoll(ajax_response);

	// we had an article redirect, destroy all tabs
	YAHOO.util.Dom.get(tab_container).innerHTML = tabResponse.firstChild.nodeValue;

	var articleResponse = fetch_tags(ajax_response, "article")[0];

	if (!articleResponse || !articleResponse.firstChild)
	{
		return false;
	}

	var tabId = articleResponse.getAttribute("tab_id");
	YAHOO.util.Dom.get("collapseobj_" + tabId).innerHTML = articleResponse.firstChild.nodeValue;

	// re-init tabs in case permissions or article status changed
	ajax_load_url[tab_container] = thread_url;

	if (vB_WikiTabs)
	{
		if (vB_WikiTabs[tab_container] && vB_WikiTabs[tab_container].overflow_tab)
		{
			var overflow_html = vB_WikiTabs[tab_container].overflow_tab.innerHTML;
		}
		else
		{
			var overflow_html = "&raquo;";
		}

		vB_WikiTabs[tab_container] = new vB_WikiTab(tab_container, tabId, overflow_html);
	}

	return false;
};

/**
* Dynamically parses Javascript
*
* @param	object	tab
* @param	object	popups
*
* @return	boolean	false
*/
vB_ResetHandler.prototype.parseScript = function(cobj, popups)
{
	var dropdowns = cobj.getElementsByTagName("script");

	var tabId = cobj.getAttribute("id");
	if (tabId != "forum_header")
	{
		tabId = tabId.split("collapseobj_")[1];
	}

	if (popups)
	{
		var existpop = YAHOO.util.Dom.get("popups_" + tabId);
		if (existpop)
		{
			existpop.parentNode.removeChild(existpop);
		}

		if (popups.firstChild)
		{
			var popdiv = document.createElement("div");
			popdiv.setAttribute("id", "popups_" + tabId);
			popdiv.innerHTML = popups.firstChild.nodeValue;
			document.body.appendChild(popdiv);

			// dropdowns.concat doesn't work?!
			var drop2 = popdiv.getElementsByTagName("script");
			if (drop2.length)
			{
				for (var p = 0; p < drop2.length; p++)
				{
					dropdowns[dropdowns.length] = drop2[p];
				}
			}
		}
	}

	if (dropdowns.length)
	{
		var i, dropHTML;
		for (var i = 0; i < dropdowns.length; i++)
		{
			if (dropdowns[i].getAttribute("type") != "text/javascript")
			{
				continue;
			}

			if (dropdowns[i].getAttribute("src"))
			{
				this.include(dropdowns[i].getAttribute("src"));
			}
			else if (dropdowns[i].innerHTML)
			{
				if (typeof PHP != "object")
				{
					return false;
				}

				dropHTML = PHP.trim(dropdowns[i].innerHTML);

				if (dropHTML.substring(0, 4) == "<!--")
				{
					dropHTML = dropHTML.substring(4);
				}

				this.eval(dropdowns[i], dropHTML);
			}
		}
	}

	return false;
};

/**
* Dynamically includes a Javascript file
*
* @param	string	javascript HTTP-path
*
* @return	boolean	false
*/
vB_ResetHandler.prototype.include = function(scriptpath)
{
	var oXML = this.getXMLHttpObj();

	if (!oXML || !scriptpath)
	{
		return false;
	}

	oXML.open("GET", scriptpath, false);
	oXML.send("");

	this.eval('', oXML.responseText);

	return false;
};

/**
* Fetch the request object for a JS include.
*
* @return	object	XMLHttpRequest || ActiveXObject
*/
vB_ResetHandler.prototype.getXMLHttpObj = function()
{
	if (typeof XMLHttpRequest != "undefined")
	{
		return new XMLHttpRequest();
	}

	var i,
		axO = [
			'Msxml2.XMLHTTP.6.0',
			'Msxml2.XMLHTTP.3.0',
			'Msxml2.XMLHTTP',
			'Microsoft.XMLHTTP'
		];

	for (i = 0; i < axO.length; i++)
	{
		try
		{
			return new ActiveXObject(axO[i]);
		}

		catch (e)
		{
		}
	}

	return null;
};

/**
* Add stylesheets for new tabs.
* IMPORTANT: Only use absolute URLs in @imports!
*
* @param	string	CSS Text
*/
vB_ResetHandler.prototype.appendCSS = function(insertStyle)
{
	if (!YAHOO.util.Dom.get("vw-custom"))
	{
		var style2 = document.createElement("style");
		style2.id = "vw-custom";
		style2.type = "text/css";

		if (style2.styleSheet && is_ie)
		{
			var importPaths;

			while (importPaths = insertStyle.match(/@import url\(\"(.*)\"\);/))
			{
				document.styleSheets[document.styleSheets.length - 1].addImport(importPaths[1]);
				insertStyle = insertStyle.replace(importPaths[0], '');
			}

			style2.styleSheet.cssText = insertStyle;
		}
		else
		{
			style2.appendChild(document.createTextNode(insertStyle));
		}

		document.getElementsByTagName("head")[0].appendChild(style2);
	}
};

/*
* Insert the HTML for a poll.
*
* @param	ajax	response
*/
vB_ResetHandler.prototype.insertPoll = function(ajax_response)
{
	var pollResponse = fetch_tags(ajax_response, "poll")[0];
	if (pollResponse)
	{
		var pollobj = YAHOO.util.Dom.get("collapseobj_ca-poll");
		if (pollobj)
		{
			pollobj.innerHTML = (pollResponse.firstChild ? pollResponse.firstChild.nodeValue : "");
		}
	}
};

vB_ResetHandler.prototype.eval = function(obj, src)
{
	window.resetObj = obj;

	if (window.execScript)
	{
		window.execScript(src);
		window.resetObj = null;

		return;
	}

	var fn = function()
	{
		window.eval.call(window, src);
	}

	fn();
	window.resetObj = null;
};

document.writeOrig = document.write;

document.write = function(src)
{
	if (window.resetObj)
	{
		var dummy = document.createElement("div");
		dummy.innerHTML = src;

		if (dummy.hasChildNodes())
		{
			for (var cn = 0; cn < dummy.childNodes.length; cn++)
			{
				YAHOO.util.Dom.insertBefore(dummy.childNodes[cn], window.resetObj);
			}
		}
	}
	else
	{
		document.writeOrig(src);
	}
};

// #############################################################################
// initialize the resetter

var vB_ResetHandle = new vB_ResetHandler();

/*======================================================================*\
 * Downloaded: 19:45, Wed Apr 11th 2012
 * Licensed to: http://www.enworld.org
\*======================================================================*/