/************************************************************************\
 *
 * VaultWiki
 * Version 3.0.17
 *
 * Copyright 2008-2012 Cracked Egg Studios. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 * 
 * VAULTWIKI IS NOT FREE SOFTWARE
 * http://www.vaultwiki.org/
 * http://www.vaultwiki.org/pages/License-Agreement
 *
\************************************************************************/

// #############################################################################
// vB_WikiTabs
// #############################################################################

var vB_WikiTabs = new Array();

// #############################################################################
// vB_WikiTab
// call using:
// vBulletin.register_control("vB_WikiTabs", tab_container, initial_tab_id, overflow_tab_label)
// #############################################################################

vBulletin.events.systemInit.subscribe(function()
{
	if (vBulletin.elements["vB_WikiTabs"])
	{
		var i,
			element;

		for (i = 0; i < vBulletin.elements["vB_WikiTabs"].length; i++)
		{
			element = vBulletin.elements["vB_WikiTabs"][i];
			vB_WikiTabs[element[0]] = new vB_WikiTab(element[0], element[1], element[2]);
		}
		vBulletin.elements["vB_WikiTabs"] = null;
	}
});

// =============================================================================

/**
* VaultWiki tabbed content
*
* @param	string	HTML element containing tab divs - each tab must be a div.content_block with a child of h4... etc.
* @param	string	Identifier of initially-selected tab
* @param	string	Text to place onto the overflow tab - recommend &raquo;
* @param	string	URL from which to request new tab content via AJAX
*/
function vB_WikiTab(tab_object, initial_tab_id, overflow_tab_string)
{

	var i,
		content_blocks,
		li,
		tab_id,
		selected_index,
		collapseobj,
		jsfail;

	console.log("Init vB_WikiTab for %s with initial tab id = %s", tab_container, initial_tab_id);
	this.tab_container = YAHOO.util.Dom.get(tab_object).parentNode;
	this.selected_tab_id = initial_tab_id;

	this.splitter = ajax_load_url[tab_object].indexOf("?") != -1 ? "?" : "&";
	this.ajax_load_url = ajax_load_url[tab_object].split(this.splitter);
	this.ajax_load_url[1] = this.ajax_load_url[1].replace(/\{(\d+)(:\w+)?\}/gi, '%$1$s');

	this.tab_count = 0;
	content_blocks = YAHOO.util.Dom.getElementsByClassName("content_block", "div", tab_container);

	if (content_blocks.length)
	{
		console.log("vB_WikiTab :: Found %d tab content blocks", content_blocks.length);

		this.tab_element = YAHOO.util.Dom.getElementsByClassName("p-cactions", "ul", tab_container)[0];
		selected_index = -1;

		for (i = 0; i < content_blocks.length; i++)
		{
			this.tab_count++;
			tab_id = content_blocks[i].getAttribute("id");

			// hide collapser
			collapseobj = YAHOO.util.Dom.get("collapseobj_" + tab_id);
			if (collapseobj)
			{
				YAHOO.util.Dom.setStyle(collapseobj, "display", "block");
			}

			if (tab_id == this.selected_tab_id)
			{
				selected_index = i;
			}
		}
	}

	// set a default tab
	if (selected_index == -1)
	{
		selected_index = 0;
		this.selected_tab_id = content_blocks[0].getAttribute("id");
	}

	// we can get duplicate tabs, so do a recount
	this.tabs = this.tab_element.getElementsByTagName("li");

	// prevent wrapped tabs from showing by setting the height of the overflow-hidden tab container
	// we have to add the class early or the height is wrong after AJAX edit
	YAHOO.util.Dom.addClass(this.tabs[selected_index], "selected");

	var tab_height = parseInt(this.tabs[selected_index].offsetHeight);
	YAHOO.util.Dom.setStyle(this.tab_element, "height", tab_height + "px");

	for (i = 0; i < this.tab_count; i++)
	{
		if (
			selected_index == i ||
			nojs_tabs.indexOf(this.tabs[i].id.split("-")[1].split("_")[0]) == "-1"
		)
		{
			this.init_tab(this.tabs[i].firstChild);
		}

		this.tabs[i].setAttribute("fixed_width", this.tabs[i].offsetWidth);
		YAHOO.util.Dom.setStyle(this.tabs[i], "display", "none");

		// we need this part of init_tab
		if (selected_index != i)
		{
			YAHOO.util.Dom.setStyle(content_blocks[i], "display", "none");
		}
	}

	// create the overflow tab
	this.overflow_tab = YAHOO.util.Dom.getElementsByClassName("overflow_tab", "li", this.tab_element)[0];
	if (typeof(this.overflow_tab) == "undefined")
	{
		var overflow_link = document.createElement("a");
		overflow_link.setAttribute("href", "javascript://");
		
		this.overflow_tab = this.tab_element.appendChild(document.createElement("li"));
		this.overflow_tab.appendChild(overflow_link);
		YAHOO.util.Dom.addClass(this.overflow_tab, "overflow_tab");
		YAHOO.util.Event.on(overflow_link, "click", this.show_menu, this, true);

		if (overflow_tab_string)
		{
			overflow_link.innerHTML = overflow_tab_string;
		}
		else
		{
			overflow_link.appendChild(document.createTextNode("&raquo;"));
		}
	}

	this.switch_tab(this.selected_tab_id, true);

	YAHOO.util.Event.on(window, "resize", this.resize, this, true);
	YAHOO.util.Event.on(document, "click", this.hide_menu, this, true);
};

/**
* Handles a click on a tab
*
* @return	boolean
*/
vB_WikiTab.prototype.click_tab = function(e)
{
	if (!YAHOO)
	{
		// occurs when changing window.location
		return false;
	}

	YAHOO.util.Event.stopEvent(e);

	var targetTab = YAHOO.util.Event.getTarget(e);
	var selected = targetTab.getAttribute("id").split("-link")[0];

	return this.switch_tab(selected);
};

/**
* Switch to a different tab
*
* @param	string	ID of tab to be selected
* @param	boolean	Force tab switch
*
* @return	boolean	false
*/
vB_WikiTab.prototype.switch_tab = function(selected_tab_id, force)
{
	if (!selected_tab_id)
	{
		return false;
	}

	if (this.selected_tab_id != selected_tab_id || force)
	{
		var i,
			tab_id,
			content_element,
			poll_show = false;

		this.hide_menu();

		this.selected_tab_id = selected_tab_id;
		this.selected_tab = YAHOO.util.Dom.get(this.selected_tab_id + "_tab");

		var poll_obj = YAHOO.util.Dom.get("collapseobj_ca-poll");

		if (
			this.selected_tab_id == "ca-poll" ||
			(
				poll_obj &&
				poll_obj.innerHTML != "" &&
				(
					this.selected_tab_id == "ca-article" ||
					this.selected_tab_id == "ca-talk"
				)
			)
		)
		{
			poll_show = true;
		}

		if (poll_obj)
		{
			YAHOO.util.Dom.setStyle(poll_obj, "display", (poll_show ? "block" : "none"));
		}

		for (i = 0; i < this.tab_count; i++)
		{
			tab_id = this.tabs[i].getAttribute("id").split("_tab")[0];

			if (tab_id == this.selected_tab_id)
			{
				if (!YAHOO.util.Dom.hasClass(this.tabs[i], "selected"))
				{
					YAHOO.util.Dom.addClass(this.tabs[i], "selected");
				}
			}
			else
			{
				YAHOO.util.Dom.removeClass(this.tabs[i], "selected");
			}

			content_element = YAHOO.util.Dom.get(tab_id);
			YAHOO.util.Dom.setStyle(content_element, "display", (tab_id == this.selected_tab_id ? "block" : "none"));

			if (tab_id == this.selected_tab_id && YAHOO.util.Dom.get("collapseobj_" + tab_id).innerHTML == "")
			{
				this.load_tab_content(this.selected_tab_id);
			}
		}

		if (!this.exiter)
		{
			console.log("vB_WikiTab :: Switched to '%s' tab", this.selected_tab_id);

			this.resize();
		}
	}

	return false;
};

/**
* Load an empty tab via POST
*
* @param	string	ID of tab to be selected
*/
vB_WikiTab.prototype.load_tab_content = function(tab_id)
{
	var load_id = tab_id.split("ca-")[1];
	var load_img = YAHOO.util.Dom.get("tab_loading_msg");
	var load_node = YAHOO.util.Dom.get("collapseobj_" + tab_id);

	if (load_node.innerHTML != "")
	{
		// this only happens if we explicitly call a refresh
		load_node.innerHTML = "";
	}

	// creating the img prevents recurrent calls
	var load_img_tab = document.createElement("div");

	load_img_tab.setAttribute("id", "tab_loading_msg_" + load_id);
	YAHOO.util.Dom.setStyle(load_img_tab, "margin", "50px");
	YAHOO.util.Dom.setStyle(load_img_tab, "textAlign", "center");
	YAHOO.util.Dom.setStyle(load_img_tab, "display", "block");
	load_img_tab.innerHTML = load_img.innerHTML;

	if (VAULT_40X_COMPAT)
	{
		var node_class = "vw-content postbit";
	}
	else
	{
		var node_class = "vw-content tborder";
	}

	if (!YAHOO.util.Dom.hasClass(load_node, node_class))
	{
		if (YAHOO.util.Dom.hasClass(load_node, "vw-broken"))
		{
			this.broken_class = true;
			YAHOO.util.Dom.removeClass(load_node, "vw-broken");
		}
		else
		{
			this.broken_class = false;
		}

		YAHOO.util.Dom.addClass(load_node, node_class);
	}

	load_node.appendChild(load_img_tab);
	this.constructed_load_url = construct_phrase(this.ajax_load_url[1], PHP.urlencode(load_id));

	YAHOO.util.Connect.asyncRequest("POST", this.ajax_load_url[0] + this.splitter + this.constructed_load_url,
	{
		success: this.ajax_complete,
		failure: this.ajax_failure,
		timeout: 15000,
		scope: this
	}, this.constructed_load_url + "&ajax=1&securitytoken=" + PHP.urlencode(SECURITYTOKEN));
};

/**
* Recalculates which tabs should be displayed after a page resize
*/
vB_WikiTab.prototype.resize = function(e)
{
	this.hide_menu();

	var total_width,
		i,
		j,
		display_tab_count,
		content_element_id,
		selected_tab,
		replace_tab,
		new_selected_tab,
		menu_element_names;

	var offset_which = YAHOO.util.Dom.getStyle(document.body, "direction") == 'ltr' ? 'left' : 'right';
	YAHOO.util.Dom.setStyle(this.overflow_tab, "display", "block");

	if (offset_which == 'right')
	{
		var offer = YAHOO.util.Dom.getRegion(this.tab_element);
	}
	else
	{
		var offer = { left: this.tab_element.offsetLeft };
	}

	var flow_width = this.overflow_tab.offsetWidth - offer[offset_which] + 10;
	YAHOO.util.Dom.setStyle(this.overflow_tab, "display", "none");

	var of_width = 0;
	total_width = this.tab_element.offsetWidth;
	display_tab_count = 0;

	for (i = 0; i < this.tab_count; i++)
	{
		YAHOO.util.Dom.setStyle(this.tabs[i], "display", "block");

		if (offset_which == 'right')
		{
			offer = YAHOO.util.Dom.getRegion(this.tabs[i]);
		}
		else
		{
			offer = { left: this.tabs[i].offsetLeft };
		}

		of_width = offer[offset_which] + Math.max(parseInt(this.tabs[i].getAttribute("fixed_width")), this.tabs[i].offsetWidth) + flow_width;

		if (of_width <= total_width)
		{
			display_tab_count++;
		}
		else
		{
			YAHOO.util.Dom.setStyle(this.tabs[i], "display", "none");
		}

		content_element_id = this.tabs[i].getAttribute("id").split("_tab")[0];
		if (content_element_id == this.selected_tab_id && YAHOO.util.Dom.getStyle(this.tabs[i], "display") == "none")
		{
			console.info("vB_WikiTab :: Moving selected tab... Found the selected tab: %d, %s", i, content_element_id);
			selected_tab = this.tabs[i];

			for (j = i; j >= 0; j--)
			{
				if (YAHOO.util.Dom.getStyle(this.tabs[j], "display") != "none")
				{
					console.log("vB_WikiTab :: Replace tab %d (%s) with %d (%s)", j, this.tabs[j].getAttribute("tab_id"), i, content_element_id);

					// placeholder for new tab
					replace_tab = this.tabs[j];
					new_selected_tab = this.tab_element.insertBefore(selected_tab.cloneNode(true), replace_tab);

					// remove the selected tab
					YAHOO.util.Event.removeListener(selected_tab, "click", this.click_tab, this, true);
					YAHOO.util.Event.removeListener(selected_tab.firstChild, "click", this.click_tab, this, true);
					selected_tab.parentNode.removeChild(selected_tab);

					YAHOO.util.Dom.setStyle(new_selected_tab, "display", "block");
					this.init_tab(new_selected_tab);

					return this.resize();
				}
			}
		}
	}

	this.display_tab_count = display_tab_count;

	// show the overflow tab and set its title
	menu_element_names = new Array();
	for (i = 1; i < this.tabs.length; i++)
	{
		if (this.tabs[i] != this.overflow_tab && YAHOO.util.Dom.getStyle(this.tabs[i], "display") == "none")
		{
			menu_element_names.push(this.tabs[i].innerHTML);
		}
	}

	this.overflow_tab.setAttribute("title", menu_element_names.join(",\n"));
	YAHOO.util.Dom.setStyle(this.overflow_tab, "display", (this.tab_count > display_tab_count ? "block" : "none"));

	// update the background position
	for (i = 0; i < this.tab_count; i++)
	{
		if (this.tabs[i].getAttribute("id").split("_tab")[0] == this.selected_tab_id)
		{
			if (offset_which == 'right')
			{
				offer = YAHOO.util.Dom.getRegion(this.tabs[i]);
			}
			else
			{
				offer = { left: this.tabs[i].offsetLeft };
			}
		
			YAHOO.util.Dom.setStyle(this.tabs[i], "backgroundPosition", (offer[offset_which] * -1) + "px 0px");
		}
		else
		{
			YAHOO.util.Dom.setStyle(this.tabs[i], "backgroundPosition", "0px 0px");
		}
	}
};

/**
* Shows the popup menu containing overflowed tabs
*
* @return	boolean	false
*/
vB_WikiTab.prototype.show_menu = function(e)
{
	YAHOO.util.Event.stopEvent(e);

	if (this.menu_open)
	{
		this.hide_menu();

		return false;
	}

	var i,
		counter,
		current_menu_element,
		menupos,
		menupos_x;

	this.menu = document.createElement("ul");
	this.menu.setAttribute("id", this.tab_element.id + "menu");

	if (VAULT_40X_COMPAT)
	{
		YAHOO.util.Dom.addClass(this.menu, "popupbody vw-menu");
		YAHOO.util.Dom.setStyle(this.menu, "display", "block");
	}
	else
	{
		YAHOO.util.Dom.addClass(this.menu, "vbmenu_popup");
		YAHOO.util.Dom.addClass(this.menu, "tab_popup");
	}

	menu_element_names = new Array();
	var linkid, newlink;
	counter = 0;

	for (i = this.display_tab_count - 1; i < this.tab_count; i++)
	{
		if (YAHOO.util.Dom.getStyle(this.tabs[i], "display") != "none")
		{
			continue;
		}

		current_menu_element = this.menu.appendChild(this.tabs[i].cloneNode(true));

		YAHOO.util.Dom.setStyle(current_menu_element, "display", "block");
		YAHOO.util.Dom.setStyle(current_menu_element, "width", "auto");

		if (!VAULT_40X_COMPAT)
		{
			YAHOO.util.Dom.addClass(current_menu_element, "vbmenu_option");
		}

		if (counter++ < 1)
		{
			YAHOO.util.Dom.addClass(current_menu_element, "first");
		}

		if (
			this.selected_tab_id != this.tabs[i].id.split("_")[0] &&
			nojs_tabs.indexOf(this.tabs[i].id.split("-")[1].split("_")[0]) == "-1"
		)
		{
			this.init_tab(current_menu_element);
		}
	}

	this.overflow_tab.appendChild(this.menu);
	menupos = YAHOO.util.Dom.getXY(this.overflow_tab);

	// check that the menu has not opened hanging off the screen
	var offset_which = YAHOO.util.Dom.getStyle(document.body, "direction") == 'ltr' ? 'left' : 'right';
	var menu_left = menupos[0] + current_menu_element.offsetWidth;
	var reference = this.overflow_tab.getElementsByTagName("a")[0];

	if (menu_left > fetch_viewport_info()["w"])
	{
		var menu_width = this.menu.offsetWidth - reference.offsetWidth;

		if (menu_width > 0)
		{
			menu_width = "-" + menu_width + "px";
		}
		else
		{
			menu_width = 0;
		}

		YAHOO.util.Dom.setStyle(this.menu, offset_which, menu_width);
	}
	else
	{
		YAHOO.util.Dom.setStyle(this.menu, offset_which, 0);
	}

	YAHOO.util.Dom.setStyle(this.menu, "top", (reference.offsetHeight - 2) + "px");

	this.menu_open = true;

	return false;
};

/**
* Hides the popup menu containing overflowed tabs
*/
vB_WikiTab.prototype.hide_menu = function()
{
	if (this.menu && this.menu_open)
	{
		this.menu.parentNode.removeChild(this.menu);
	}

	this.menu_open = false;
};

/**
* Initializes a tab with event listeners etc.
*
* @param	object	HTML tab (A) element
* @param	boolean	Extract full title for tab
*/
vB_WikiTab.prototype.init_tab = function(tab_element)
{
	YAHOO.util.Event.on(tab_element, "click", this.click_tab, this, true);
};

/**
* Process the POST response.
*
* @param	object	YUI AJAX
*
* @param	boolean	false
*/
vB_WikiTab.prototype.ajax_complete = function(ajax)
{
	if (ajax.responseXML)
	{
		if (VAULT_40X_COMPAT)
		{
			var node_class = "vw-content postbit";
		}
		else
		{
			var node_class = "vw-content tborder";
		}

		if (fetch_tag_count(ajax.responseXML, "error"))
		{
			// do nothing
			var articleResponse = fetch_tags(ajax.responseXML, "error")[0];
			var tabId = articleResponse.getAttribute("tab_id");

			if (!tabId)
			{
				return false;
			}

			var collapseobj = YAHOO.util.Dom.get("collapseobj_" + tabId);
			if (!collapseobj)
			{
				return false;
			}

			collapseobj.innerHTML = "";

			if (!YAHOO.util.Dom.hasClass(collapseobj, node_class))
			{
				YAHOO.util.Dom.addClass(collapseobj, node_class);
			}

			var error_box = document.createElement("table");

			if (VAULT_40X_COMPAT)
			{
				YAHOO.util.Dom.addClass(error_box, "postbody");
			}

			YAHOO.util.Dom.setStyle(error_box, "margin", "50px");
			YAHOO.util.Dom.setStyle(error_box, "display", "block");

			var error_img = document.createElement("img");
			YAHOO.util.Dom.setStyle(error_img, "margin-right", "20px");

			if (is_ie && !is_ie7)
			{
				error_img.src = VAULT_IMGDIR + "/vault_error.gif";
			}
			else
			{
				error_img.src = VAULT_IMGDIR + "/vault_error.png";
			}

			error_img.alt = "";
			error_img.border = 0;

			var error_ibox = document.createElement("td");
			YAHOO.util.Dom.setStyle(error_ibox, "vertical-align", "middle");
			error_ibox.appendChild(error_img);

			var error_msg = document.createElement("td");
			YAHOO.util.Dom.setStyle(error_msg, "vertical-align", "middle");
			error_msg.innerHTML = articleResponse.firstChild.nodeValue;

			var error_row = document.createElement("tr");
			error_row.appendChild(error_ibox);
			error_row.appendChild(error_msg);
			error_box.appendChild(error_row);

			collapseobj.appendChild(error_box);
		}
		else
		{
			var tab_id;
			var articleResponse = fetch_tags(ajax.responseXML, "article")[0];
			var articleId = fetch_tags(ajax.responseXML, "url")[0];

			if (!articleResponse || !articleId)
			{
				return false;
			}

			var tabId = articleResponse.getAttribute("tab_id");
			if (!tabId)
			{
				return false;
			}

			var collapseobj = YAHOO.util.Dom.get("collapseobj_" + tabId);
			if (!collapseobj)
			{
				return false;
			}

			var threadurl = articleId.firstChild.nodeValue.replace(/\{(\d+)(:\w+)?\}/gi, '%$1$s');
			if (this.ajax_load_url[0] + this.splitter + this.ajax_load_url[1] != threadurl)
			{
				if (vB_ResetHandle.parseRedirect(ajax.responseXML, threadurl))
				{
					this.exiter = true;

					return false;
				}
			}
			else
			{
				if (tabId == "ca-article" || tabId == "ca-talk")
				{
					vB_ResetHandle.insertPoll(ajax.responseXML);
				}

				YAHOO.util.Dom.setStyle(collapseobj, "width", "100%");
				collapseobj.innerHTML = articleResponse.firstChild.nodeValue;
			}

			if (YAHOO.util.Dom.hasClass(collapseobj, node_class))
			{
				if (this.broken_class)
				{
					YAHOO.util.Dom.addClass(collapseobj, "vw-broken");
					this.broken_class = false;
				}

				// this was dynamically set to look nice with the loading img
				YAHOO.util.Dom.removeClass(collapseobj, node_class);
			}

			// re-init auto-links
			if (
				(tabId == "ca-article" || tabId == "ca-talk") &&
				YAHOO.util.Dom.getElementsByClassName("autolink", "a", collapseobj) &&
				typeof SpecialAutoLink == "object"
			)
			{
				SpecialAutoLink = new Special_AutoLink();
			}

			// init dropdown, quick-edit, etc.
			vB_ResetHandle.parseScript(collapseobj, fetch_tags(ajax.responseXML, "popups")[0]);

			if (VAULT_40X_COMPAT)
			{
				vBulletin.events.systemInit.fired = false;
				vBulletin.events.systemInit.fire();

				YAHOO.vBulletin.vB_XHTML_Ready = false;
				vB_XHTML_Ready.fire();
				YAHOO.vBulletin.vB_XHTML_Ready = true;
			}
		}
	}

	return false;
};

/**
* Redirect to the URL on failure
*
* @param	object	YUI AJAX
*/
vB_WikiTab.prototype.ajax_failure = function(ajax)
{
	vBulletin_AJAX_Error_Handler(ajax);

	window.location = this.ajax_load_url[0] + this.splitter + this.constructed_load_url;
};

/**
* Handles AJAX errors
*
* @param	object	YUI AJAX
*/
vB_WikiTab.prototype.handle_ajax_error = function(ajax)
{
	vBulletin_AJAX_Error_Handler(ajax);
};

/*======================================================================*\
 * Downloaded: 19:45, Wed Apr 11th 2012
 * Licensed to: http://www.enworld.org
\*======================================================================*/